static char rcsid[] = "$Id: dbugobj.c,v 1.5 1997/01/31 05:13:30 ngoddard Exp $";

/*
** $Log: dbugobj.c,v $
** Revision 1.5  1997/01/31 05:13:30  ngoddard
** barriers don't complete asyncs now, minor bug fixes
**
** Revision 1.4  1997/01/21 22:19:54  ngoddard
** paragon port
**
** $Log: dbugobj.c,v $
** Revision 1.5  1997/01/31 05:13:30  ngoddard
** barriers don't complete asyncs now, minor bug fixes
**
** Revision 1.3  1997/01/21 20:19:19  ngoddard
** bug fixes for zones, implement string literal fields, first release of pgenesis script
**
** Revision 1.2  1996/06/21 17:33:01  ngoddard
** new Msg structure
**
 * Revision 1.1  1995/04/11  17:11:29  ngoddard
 * Initial revision
 *
*/

#include "dbug_ext.h"

/*
** An object for testing the parallel library.
** For now it simply sets its value to the sum of the incoming values
** 
*/

#define MSGACTIVE(M) ((M)->type < 0)

DbugFunc(dbg,action)
     register struct dbug_type *dbg;
     Action *action;
{
  MsgIn	*msg;
  MsgOut * msgout;
  int i;
  double time = SimulationTime();

  SELECT_ACTION(action){
  case PROCESS:
    dbg->value += 1;
    MSGLOOP(dbg,msg)
      {
      case PASSIVE1:
	printf ("Node %f : passive_one (%f) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), time);
	break;
      case PASSIVE2:
	printf ("Node %f : passive_two (%f, %f) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), MSGVALUE(msg,1), time);
	break;
      case PASSIVE3:
	printf ("Node %f : passive_three (%f, %f, %f) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), MSGVALUE(msg,1), 
		MSGVALUE(msg,2), time);
	break;
	
      case PASSIVE1_D:
	printf ("Node %f : passive_one_d (%lf) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), time);
	break;
      case PASSIVE2_D:
	printf ("Node %f : passive_two_d (%lf, %lf) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), MSGVALUE(msg,1), time);
	break;
      case PASSIVE3_D:
	printf ("Node %f : passive_three_d (%lf, %lf, %lf) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), MSGVALUE(msg,1), 
		MSGVALUE(msg,2), time);
	break;
	
      case PASSIVE1_S:
	printf ("Node %f : passive_one_s (%d) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), time);
	break;
      case PASSIVE2_S:
	printf ("Node %f : passive_two_s (%d, %d) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), MSGVALUE(msg,1), time);
	break;
      case PASSIVE3_S:
	printf ("Node %f : passive_three_s (%d, %d, %d) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), MSGVALUE(msg,1), 
		MSGVALUE(msg,2), time);
	break;
	
      case PASSIVE1_I:
	printf ("Node %f : passive_one_i (%d) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), time);
	break;
	
      case PASSIVE2_I:
	printf ("Node %f : passive_two_i (%d, %d) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), MSGVALUE(msg,1), time);
	break;
      case PASSIVE3_I:
	printf ("Node %f : passive_three_i (%d, %d, %d) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), MSGVALUE(msg,1), 
		MSGVALUE(msg,2), time);
	break;
	
      case PASSIVE1_C:
	printf ("Node %f : passive_one_c (%c) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), time);
	break;
	
      case PASSIVE2_C:
	printf ("Node %f : passive_two_c (%c, %c) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), MSGVALUE(msg,1), time);
	break;
      case PASSIVE3_C:
	printf ("Node %f : passive_three_c (%c, %c, %c) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), MSGVALUE(msg,1), 
		MSGVALUE(msg,2), time);
	break;
	
      case PASSIVE1_ST:
	printf ("Node %f : passive_one_st (%s) at %lf\n",
		dbg->init_value, MSGPTR(msg,0), time);
	break;
	
      case PASSIVE2_ST:
	printf ("Node %f : passive_two_st (%s, %s) at %lf\n",
		dbg->init_value, MSGPTR(msg,0), MSGPTR(msg,1), time);
	break;
      case PASSIVE3_ST:
	printf ("Node %f : passive_three_st (%s, %s, %s) at %lf\n",
		dbg->init_value, MSGPTR(msg,0), MSGPTR(msg,1), 
		MSGPTR(msg,2), time);
	break;
	
      case PASSIVE0_N:
	printf ("%d @ %d : message zero() from %f @ %f at time %lf\n",
		dbg->s_value, dbg->my_node, MSGVALUE(msg,0), 
		MSGVALUE(msg,1), time);
	break;
	
      case PASSIVE1_N:
	printf ("%d @ %d : message one(%f) from %f @ %f at time %lf\n",
		dbg->s_value,  dbg->my_node, MSGVALUE(msg,2), 
		MSGVALUE(msg,0), MSGVALUE(msg,1), time);
	break;
	
      case PASSIVE2_N:
	printf ("%d @ %d: message two(%f,%f) from %f @ %f at time %lf\n",
		dbg->s_value, dbg->my_node, MSGVALUE(msg,2), 
		MSGVALUE(msg,3), MSGVALUE(msg,0), MSGVALUE(msg,1), time);
	break;
	
      case PASSIVE3_N:
	printf ("%d @ %d: message three(%f, %f, %f) from %f @ %f at time %lf\n",
		dbg->s_value, dbg->my_node, MSGVALUE(msg,2), 
		MSGVALUE(msg,3), MSGVALUE(msg,4), MSGVALUE(msg,0), 
		MSGVALUE(msg,1), time);
	break;
      case PASSIVE5_MIXA:
	printf ("Node %f : passive_five_mixa (%s, %f, %s, %f, %f) at %lf\n",
		dbg->init_value, MSGPTR(msg,0), MSGVALUE(msg,1), 
		MSGPTR(msg,2), MSGVALUE(msg,3),	MSGVALUE(msg,4), time);
	break;
      case PASSIVE5_MIXB:
	printf ("Node %f : passive_five_mixb (%f, %s, %s, %f, %f) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), MSGPTR(msg,1),
		MSGPTR(msg, 2), MSGVALUE(msg,3), MSGVALUE(msg,4), time);
	break;
      case PASSIVE5_MIXC:
	printf ("Node %f : passive_five_mixc (%f, %s, %f, %f, %s) at %lf\n",
		dbg->init_value, MSGVALUE(msg,0), MSGPTR(msg,1),
		MSGVALUE(msg,2), MSGVALUE(msg,3), MSGPTR(msg, 4), time);
	break;
      case PASSIVE0:
	printf ("Node %f : passive_zero () at %lf\n", dbg->init_value, time);
	break;
      case ACTIVEM:
	break;
      default:
	printf ("Node %f : Unknown message type at %lf\n", dbg->init_value);
    }

    /* send EVENTS */
    if (dbg->value > 9) {
	dbg->value = 0;
      MSGOUTLOOP(dbg, msgout) {
	if (MSGACTIVE(msgout))
	  CallEventAction(dbg, msgout, time);
      }
      }
    break;
  case EVENT:
      {
	MsgIn * msg = (MsgIn*) action->data;
	double * time = (double *) action->argv;
	printf("Node %f : got active message at time %lf\n", dbg->init_value,
	       SimulationTime());
      }
    break;
  case RESET:
    dbg->value = 0;
    dbg->init_value = 0;
    dbg->init_value = 0;
    dbg->c_value = '0';
    dbg->s_value = 0;
    dbg->my_name = "UNNAMED";
    dbg->d_value = 0.0;
    dbg->my_node = -1;
    break;

  case DBUGSETNODE:
    if (action->argc != 2) 
	fprintf (stderr, "Invalid number of arguments for dbgsetnode\n");
    else
	dbg->init_value = atof (action->argv[1]);
  break;

  case DBUGCREATE:
    dbg->value = dbg->init_value = 0;
    break;
  case DBUGDISPLAY:
    fprintf(stdout, "Dbg val: %d ival: %d\n", dbg->value, dbg->init_value);
    /* show messages? */
    break;
  }
}




