//
// $Log: beta1.g,v $
// Revision 1.7  1997/01/31 05:14:06  ngoddard
// barriers don't complete asyncs now, minor bug fixes
//
// Revision 1.6  1997/01/21 22:20:13  ngoddard
// paragon port
//
// Revision 1.5  1995/05/02 22:06:56  ngoddard
// changed to use -execdir and -altsimrc
//
//Revision 1.4  1995/05/02  19:25:07  ngoddard
//*** empty log message ***
//
//Revision 1.3  1995/04/11  04:26:06  ngoddard
//Patch-1-test
//
//Revision 1.2  1995/04/05  00:48:29  ngoddard
//commented out call to pvm until we can get PATH set properly
//
// Revision 1.1  1995/04/03  21:42:11  ngoddard
// Initial revision
//
//
//This script starts up a number of nodes, issues some remote commands,
//executes some barriers, creates an object on each node, links them in
//two rings of messages (one active, one passive), sets a token in the
//object on the master node, and simulates some steps.  The token passes
//around the ring, one node per step.  Whenever a node receives the
//token, it sends an active message to the successor.  Whenever a node
//receives an active message it prints out the time sent and the time
//received.  The master node writes out it's value, which is the token's
//value whenever it has the token and zero at other times.  Thus, if
//there are n nodes the token should appear every n steps.
//
//The script echoes what it is doing on each node.  It directs worker output
//to a file "workers.out" in the directory in which the master is run.
//
// Sample output from the master and the workers is appended.

// set the number of nodes
setenv NNODES 4
// turn on parlib, send worker output to "workers.out"
paron -nodes 4 -silent 2 -output workers.out -altsimrc ../.simrc -executable pargenbeta -parallel

int node = {mynode}
//if ({node} == 0)
//	printenv PATH > pvm.process
//	echo "ps -a " | pvm >> pvm.process
//end

if ({node} == 0)
	echo running with {nnodes} nodes
	echo local hello from {mynode}
end
if ({node} == 1)
	echo@0 hello from {mynode}
end
if ({node} == 0)
	echo synchronize
end
barrier 1
//echo create a debug object
create dbg /dbg
//echo reset
reset
//echo synchronize
barrier 2
//echo make a link to the debug object on the next node
int nextnode = {node}+1
if ({nextnode} == {nnodes})
  nextnode = 0
end
//echo make the link
raddmsg /dbg /dbg@{nextnode} INPUT value
raddmsg /dbg /dbg@{nextnode} ACTIVE
//echo set the token in the object on node 0
if ({node} == 0)
  setfield /dbg value 5
end
//echo set the reference value for active messages
setfield /dbg init_value 4
//echo do some steps, node 0 prints its value
//echo token should appear every nnode steps
//echo synchronize
barrier 3
int i, j
//setfield /post sync_before_step 0
//setfield /post msg_hang_time 10
for (i = 0; i < 20; i = i+1)
  if ({node} == 0)
    echo i = {i}, value = {getfield /dbg value}
  end
//  echo@0 {mynode} stepping...
  step
//  echo@0 {mynode} stepped...
end
//echo cleanup and exit
//echo synchronize
barrier
//echo paroff
paroff
//echo quit
quit
echo ERROR: went past quit

